#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ChannelCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ChannelCFG> M_ChannelCFG::msSingleton(nullptr);

int M_ChannelCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ChannelCFGData* M_ChannelCFG::GetData(std::string ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<std::string, M_ChannelCFGData>& M_ChannelCFG::GetMapData()
{
	return mMapData;
}

void M_ChannelCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ChannelCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ChannelCFGData data;
		data.mID = element->Attribute("ID");
		data.mIsPayWeb = element->IntAttribute("IsPayWeb");
		data.mShowUI = element->IntAttribute("ShowUI");
		data.mDesc = element->Attribute("Desc");
		data.mName = element->Attribute("Name");
		data.mVersionName = element->Attribute("VersionName");
		data.mVersionCode = element->IntAttribute("VersionCode");
		data.mPath = element->Attribute("Path");
		data.mPlatform = element->Attribute("Platform");
		data.mPackageName = element->Attribute("PackageName");
		data.mLogo = element->Attribute("Logo");
		data.mEnableSplash = element->BoolAttribute("EnableSplash");
		data.mEnableRealName = element->BoolAttribute("EnableRealName");
		data.mInfo = element->Attribute("Info");
		data.mChargingCharge = element->IntAttribute("ChargingCharge");
		data.mCompany = element->Attribute("Company");
		data.mExchangeLimit = element->IntAttribute("ExchangeLimit");
		data.mRankShow = element->IntAttribute("RankShow");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ChannelCFG::Load()
{
	Load("../Config/M_ChannelCFG.xml");
}

M_ChannelCFG* M_ChannelCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ChannelCFG());
	}
	return msSingleton.get();
}
